
/*
**
**	example of using initlib
**
**	goran larsson    hacker@isadora.ikp.liu.se
**
**	compile: cc -o example example.c initlib.o
*/

static char RCSid[] = "$Header: example.c,v 1.1 89/03/12 23:18:27 root Exp $";

/*
 *	$Log:	example.c,v $
 * Revision 1.1  89/03/12  23:18:27  root
 * Initial revision
 * 
 */

#include <stdio.h>
#include "init.h"

main ( argc, argv )
int argc;
char *argv[];

{
	FILE *f;

	if ( argc != 2 ) {
		usage ();
		exit ( 1 );
	}

	switch ( *argv[1] ) {

		/*
		** bad option
		*/

	default:
		usage ();
		exit ( 1 );

		/*
		** display current init state
		*/

	case 's':
		printf ( "init state is '%c'\n", init ( INIT_OPR_STATE, 0 ) );
		break;

		/*
		** disable logins
		*/

	case 'd':
		foo ( init ( INIT_OPR_CMD, INIT_INHIBIT ) );
		unlink ( "/etc/nologin" );
		if ( ( f = fopen ( "/etc/nologin", "w" ) ) != NULL ) {
			fprintf ( f, "No logins, sorry\n" );
			close ( f );
		}
		break;

		/*
		** enable logins
		*/

	case 'e':
		foo ( init ( INIT_OPR_CMD, INIT_MERGE ) );
		unlink ( "/etc/nologin" );
		break;
	}
}

usage ()

{
	printf ( "usage: example e     enable logins\n" );
	printf ( "       example d     disable logins\n" );
	printf ( "       example s     show init state\n" );
}

foo ( status )
int status;

{
	switch ( status ) {
	case INIT_OK:
		break;
	case INIT_ERR_SHM:
		printf ( "example: can not attach shared memory\n" );
		break;
	case INIT_ERR_BUSY:
		printf ( "example: init busy!\n" );
		break;
	case INIT_ERR_CMD:
		printf ( "example: bad command\n" );
		break;
	case INIT_ERR_OPR:
		printf ( "example: bad operation\n" );
		break;
	case INIT_ERR_DONE:
		printf ( "example: init did not signal done\n" );
		break;
	default:
		printf ( "example: unknown init result code: %d\n", status );
		break;
	};
}
